Package weka.classifiers.mi

# Class MDD

java.lang.Object
weka.classifiers.Classifier
weka.classifiers.mi.MDD

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `CapabilitiesHandler`, `MultiInstanceCapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `TechnicalInformationHandler`

public class MDD extends Classifier implements OptionHandler, MultiInstanceCapabilitiesHandler, TechnicalInformationHandler
Modified Diverse Density algorithm, with collective assumption.
More information about DD:
Oded Maron (1998). Learning from ambiguity.
O. Maron, T. Lozano-Perez (1998). A Framework for Multiple Instance Learning. Neural Information Processing Systems. 10.

BibTeX:

     @phdthesis{Maron1998,
        author = {Oded Maron},
        school = {Massachusetts Institute of Technology},
        title = {Learning from ambiguity},
        year = {1998}
     }

     @article{Maron1998,
        author = {O. Maron and T. Lozano-Perez},
        journal = {Neural Information Processing Systems},
        title = {A Framework for Multiple Instance Learning},
        volume = {10},
        year = {1998}
     }

Valid options are:

     -D
      Turn on debugging output.

     -N <num>
      Whether to 0=normalize/1=standardize/2=neither.
      (default 1=standardize)

Version:
  $Revision: 9144 $
Author:
  Eibe Frank (eibe@cs.waikato.ac.nz), Xin Xu (xx5@cs.waikato.ac.nz)
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`FILTER_NONE`
No normalization/standardization
`static final int`
`FILTER_NORMALIZE`
Normalize training data
`static final int`
`FILTER_STANDARDIZE`
Standardize training data
`static final Tag[]`
`TAGS_FILTER`
The filter to apply to the training data

## Constructor Summary

Constructors
Constructor
Description
`MDD()`

## Method Summary

Modifier and Type
Method
Description
`void`
`buildClassifier(Instances train)`
Builds the classifier
`double[]`
`distributionForInstance(Instance exmp)`
Computes the distribution for a given exemplar
`String`
`filterTypeTipText()`
Returns the tip text for this property
`Capabilities`
`getCapabilities()`
Returns default capabilities of the classifier.
`SelectedTag`
`getFilterType()`
Gets how the training data will be transformed.
`Capabilities`
`getMultiInstanceCapabilities()`
Returns the capabilities of this multi-instance classifier for the relational data.
`String[]`
`getOptions()`
Gets the current settings of the classifier.
`String`
`getRevision()`
Returns the revision string.
`TechnicalInformation`
`getTechnicalInformation()`
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`String`
`globalInfo()`
Returns a string describing this filter
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options
`static void`
`main(String[] argv)`
Main method for testing this class.
`void`
`setFilterType(SelectedTag newType)`
Sets how the training data will be transformed.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`String`
`toString()`
Gets a string describing the classifier.

### Methods inherited from class weka.classifiers.Classifier

`classifyInstance, debugTipText, forName, getDebug, makeCopies, makeCopy, setDebug`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### FILTER_NORMALIZE

public static final int FILTER_NORMALIZE
Normalize training data

See Also:
  - Constant Field Values

### FILTER_STANDARDIZE

public static final int FILTER_STANDARDIZE
Standardize training data

See Also:
  - Constant Field Values

### FILTER_NONE

public static final int FILTER_NONE
No normalization/standardization

See Also:
  - Constant Field Values

### TAGS_FILTER

public static final Tag[] TAGS_FILTER
The filter to apply to the training data

## Constructor Details

### MDD

public MDD()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

public TechnicalInformation getTechnicalInformation()
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

Specified by:
  `getTechnicalInformation` in interface `TechnicalInformationHandler`
Returns:
  the technical information about this class

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options

Specified by:
  `listOptions` in interface `OptionHandler`
Overrides:
  `listOptions` in class `Classifier`
Returns:
  an enumeration of all the available options

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Specified by:
  `setOptions` in interface `OptionHandler`
Overrides:
  `setOptions` in class `Classifier`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the classifier.

Specified by:
  `getOptions` in interface `OptionHandler`
Overrides:
  `getOptions` in class `Classifier`
Returns:
  an array of strings suitable for passing to setOptions

### filterTypeTipText

public String filterTypeTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getFilterType

public SelectedTag getFilterType()
Gets how the training data will be transformed. Will be one of FILTER_NORMALIZE, FILTER_STANDARDIZE, FILTER_NONE.

Returns:
  the filtering mode

### setFilterType

public void setFilterType(SelectedTag newType)
Sets how the training data will be transformed. Should be one of FILTER_NORMALIZE, FILTER_STANDARDIZE, FILTER_NONE.

Parameters:
  `newType` - the new filtering mode

### getCapabilities

public Capabilities getCapabilities()
Returns default capabilities of the classifier.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Classifier`
Returns:
  the capabilities of this classifier
See Also:
  - `Capabilities`

### getMultiInstanceCapabilities

public Capabilities getMultiInstanceCapabilities()
Returns the capabilities of this multi-instance classifier for the relational data.

Specified by:
  `getMultiInstanceCapabilities` in interface `MultiInstanceCapabilitiesHandler`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### buildClassifier

public void buildClassifier(Instances train) throws Exception
Builds the classifier

Specified by:
  `buildClassifier` in class `Classifier`
Parameters:
  `train` - the training data to be used for generating the boosted classifier.
Throws:
  `Exception` - if the classifier could not be built successfully

### distributionForInstance

public double[] distributionForInstance(Instance exmp) throws Exception
Computes the distribution for a given exemplar

Overrides:
  `distributionForInstance` in class `Classifier`
Parameters:
  `exmp` - the exemplar for which distribution is computed
Returns:
  the distribution
Throws:
  `Exception` - if the distribution can't be computed successfully

### toString

public String toString()
Gets a string describing the classifier.

Overrides:
  `toString` in class `Object`
Returns:
  a string describing the classifer built.

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Classifier`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - should contain the command line arguments to the scheme (see Evaluation)